package com.mchim.ClinetHub;

package ..deTemp.1740922757689;

import com.mchim.ClinetHub.GUI.Chat.Custom.CustomGuiChat;
import com.mchim.ClinetHub.GUI.Chat.Listeners.ChatListeners;
import com.mchim.ClinetHub.GUI.GuiManager;
import com.mchim.ClinetHub.GUI.PlayerViewer.ViewerListener;
import com.mchim.ClinetHub.Key.CustomKey.AbstractCustomKey;
import com.mchim.ClinetHub.Key.CustomKey.CustomSkillKey;
import com.mchim.ClinetHub.Key.KeyManager;
import com.mchim.ClinetHub.Listeners.ActionListeners;
import com.mchim.ClinetHub.Listeners.KeyListeners;
import com.mchim.ClinetHub.Listeners.RenderListeners;
import com.mchim.ClinetHub.Monitor.ClientMonitor;
import com.mchim.ClinetHub.Net.Packet.PacketManager;
import com.mchim.ClinetHub.Net.PacketHandler;
import com.mchim.ClinetHub.Net.PacketListeners;
import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.client.registry.ClientRegistry;
import net.minecraftforge.fml.common.FMLLog;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.event.FMLLoadCompleteEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.EventBus;
import net.minecraftforge.fml.common.network.FMLEventChannel;
import net.minecraftforge.fml.common.network.NetworkRegistry;

@Mod(modid = "clienthub", name = "ClientHub", version = "1.0.1", clientSideOnly = true, acceptedMinecraftVersions = "[1.12.2]")
public class ClientHub {
  public static final String MODID = "clienthub";
  
  public static final String Name = "ClientHub";
  
  protected static final String VERSION = "1.0.1";
  
  public static final String Channel_Name = "ClientHub";
  
  private static FMLEventChannel channel;
  
  public static KeyManager keyManager = new KeyManager();
  
  public static PacketManager packetManager;
  
  public static PacketHandler packetHandler = new PacketHandler();
  
  public static GuiManager guiManager = new GuiManager();
  
  public static Minecraft mc;
  
  public static final ResourceLocation texture = new ResourceLocation("clienthub", "gui.png");
  
  public static final ResourceLocation emoji = new ResourceLocation("clienthub", "emoji.png");
  
  public static final ResourceLocation itemLore = new ResourceLocation("clienthub", "itemlore.png");
  
  public static CustomGuiChat.ChatChannel chatChannel = CustomGuiChat.ChatChannel.bungee;
  
  public static ClientMonitor clientMonitor;
  
  public static final String updateIp = "update.i7mc.cn:28883";
  
  public static boolean isTagVisble = false;
  
  public static KeyBinding seePlayerEquip;
  
  @EventHandler
  public void preInit(FMLPreInitializationEvent e) {
    mc = Minecraft.func_71410_x();
    keyManager.register((AbstractCustomKey)new CustomSkillKey());
  }
  
  @EventHandler
  public void preload(FMLPreInitializationEvent e) {
    registerListeners();
    registerChannel();
    registerKey();
    FMLLog.log.info("MessageHub已经启动.........");
    guiManager.registerGui();
    guiManager.registerElement();
  }
  
  @EventHandler
  public void loaded(FMLLoadCompleteEvent e) {
    try {
      clientMonitor = new ClientMonitor();
    } catch (ClassNotFoundException e1) {
      e1.printStackTrace();
    } 
  }
  
  private void registerListeners() {
    EventBus ebus = MinecraftForge.EVENT_BUS;
    ebus.register(new KeyListeners());
    ebus.register(new RenderListeners());
    ebus.register(new ActionListeners());
    ebus.register(new ChatListeners());
    ebus.register(new ViewerListener());
  }
  
  private void registerChannel() {
    channel = NetworkRegistry.INSTANCE.newEventDrivenChannel("ClientHub");
    PacketListeners pl = new PacketListeners();
    MinecraftForge.EVENT_BUS.register(pl);
    channel.register(pl);
    packetManager = new PacketManager(channel);
  }
  
  public void registerKey() {
    seePlayerEquip = new KeyBinding("查看对方装备", 45, "key.categories.gameplay");
    ClientRegistry.registerKeyBinding(seePlayerEquip);
  }
}
